// This script is part of the QUALITY MANAGEMENT app available in the App Store
// Last modification date: Mar 2nd, 2021


switch(customTransID) {
    
    case 'NEW':
        reset();
        break;
    
    case 'SUBMIT':
        item.STEP =  item.STEP + 1;
        createMilestones();
        break;
        
    case 'PROCEED_TO_MEASUREMENT':
        saveProgress(1);
        break;
    
    case 'PROCEED_TO_ANALYSIS':
        saveProgress(2);
        break;
    
    case 'PROCEED_TO_IMPROVEMENT':
        saveProgress(3);
        break;
    
    case 'PROCEED_TO_CONTROL':
        saveProgress(4);
        break;
    
    case 'RETURN_1':
    case 'RETURN_2':
    case 'RETURN_3':
    case 'RETURN_4':
        item.STEP = item.STEP - 1;
        break;
    
    case 'CLOSE':
        item.STEP = 10;
        saveProgress(5);
        initCR();
        updateRelatedProcess('SPAWNED_BY_NCR', 'CAPA In Progress', 'CAPA_COMPLETE');
        updateRelatedProcess('RELATED_RMA', 'CAPA In Progress', 'CAPA_COMPLETE');
        updateRelatedPR();
        break;
    
}


function reset() {
    
    item.STEP = 0;
    
    for(var i = 1; i <= 5; i++) {
        item["COMPLETION_DATE_" + i]     = null;
        item["COMPLETED_BY_" + i]        = null;
        item["COMPLETION_COMMENTS_" + i] = null;
    }
    
    item.RELATED_CR = null;
    
    resetReference('SPAWNED_BY_NCR', 'RELATED_CAPA');
    resetReference('RELATED_RMA', 'RELATED_CAPA');
    resetReference('RELATED_PR', 'CAPA');
    
}
function resetReference(fieldId, fieldLink) {
    
    if(item[fieldId] === null) return;
    if(item[fieldId][fieldLink] === null) return;
    if(item[fieldId][fieldLink] !== item)  item[fieldId] = null;
    
}
    



function createMilestones() {
    
    var dateBase = new Date();
    
    for(var i = 0; i < milestonesCAPA.length; i++) {
        dateBase = createMilestone(milestonesCAPA[i].name,  milestonesCAPA[i].percent, milestonesCAPA[i].offset, dateBase);
    }
    
}
function createMilestone(status, progress, offset, dateBase) {
    
    dateBase.setDate(dateBase.getDate() + offset);
    
	var milestone = item.addMilestone();
	    milestone.setWorkflowState(status);
	    milestone.milestoneType = "EXIT";
	    milestone.milestoneDate = dateBase;
	    milestone.warnThreshold = 3;
        milestone.progress = "0";
    
    return dateBase;
    
}


function saveProgress(index) {
    
    item.STEP =  item.STEP + 1;
    
    item["COMPLETION_DATE_" + index] = new Date();
    item["COMPLETED_BY_" + index] = getUserName();
    item["COMPLETION_COMMENTS_" + index] = item.workflowActions[0].comments;
    
}


function initCR() {
    
    if(wsChangeRequests === null) return;
    if(wsChangeRequests === "") return;
    if(item.CREATE_CHANGE_REQUEST === null) return;
    if(item.CREATE_CHANGE_REQUEST === 'No') return;
    
	var newItem = createItem(wsChangeRequests);
	    newItem.TITLE = item.TITLE;
	    newItem.DESCRIPTION = item.PROBLEM_STATEMENT;
        newItem.CAPA = item;
        newItem.PROBLEM_REPORT = item.RELATED_PR;
    
    item.RELATED_CR = newItem;

}
function updateRelatedProcess(fieldId, workflowState, transitionId) {
    
    if(item[fieldId] === null) return;
    
    var elemProcess = item[fieldId];
    
    if(elemProcess.descriptor.workflowState === workflowState) elemProcess.performWorkflowTransitionByCustomID(transitionId, 'Closed by CAPA');
    
}
function updateRelatedPR() {
    
    if(item.RELATED_PR === null) return;
    
    var elemPR = item.RELATED_PR;
    
    if(item.RELATED_CR !== null) {
        elemPR.CR_REQUESTED = "Yes";
        elemPR.CHANGE_REQUEST = item.RELATED_CR;
        elemPR.CR_CREATION_DATE = new Date();
        elemPR.performWorkflowTransitionByCustomID('INITIATE_CHANGE_REQUEST_FROM_CAPA', 'Change Request initiated by CAPA');
    } else {
        elemPR.CR_REQUESTED = "No";
        elemPR.performWorkflowTransitionByCustomID('CAPA_COMPLETED', 'Closed by CAPA');
    }
       
}