// This script is part of the CLAIM MANAGEMENT app available in the App Store
// Last modification date: Mar 2nd, 2021

switch(customTransID) {
        
    case 'CREATE':
        reset();
        break;

    case 'CLARIFICATION':
        appendToThread("CLARIFICATION_LOG");
        addWorkflowComment("CLAIM_CLARIFICATION_COMMENT");
        item.CLAIM_CLARIFICATION_COMPLETE_DATE = null;
        break;
        
    case 'CLARIFIED':    
        appendToThread("CLARIFICATION_LOG");
        addWorkflowComment("CLAIM_CLARIFICATION_COMMENT");
        item.CLAIM_CLARIFICATION_COMPLETE_DATE = new Date();
        break;
        
    case 'APPROVE_CLAIM':    
        item.CLAIM_HANDLER_COMPLETE_DATE = new Date();
        addWorkflowComment("CLAIM_HANDLER_COMMENT");
        break;
        
    case 'CLOSE_CLAIM':    
        addWorkflowComment("CLAIM_COSTING_COMMENT");
        item.CLAIM_COST_COMPLETE_DATE = new Date();
        calculateClaimDuration(item.INCIDENT_DATE,new Date());
        item.COMPLETION_DATE = new Date();
        break;
        
    case 'FURTHER_INVESTIGATION':    
        addWorkflowComment("CLAIM_COSTING_COMMENT");
        item.CLAIM_HANDLER_COMPLETE_DATE = null;
        break;
    
    case 'RE_COST':    
        addWorkflowComment("CLAIM_COSTING_COMMENT");
        item.CLAIM_COST_COMPLETE_DATE = null;
        item.CLAIM_DURATION = null;
        break;
    
    case 'RE_OPEN_CLAIM':    
        addWorkflowComment("CLAIM_COSTING_COMMENT");
        item.CLAIM_HANDLER_COMPLETE_DATE = null;
        item.CLAIM_COST_COMPLETE_DATE = null;
        item.CLAIM_DURATION = null;
        break;
    
    case 'INVALIDATE_CLAIM':  
        addWorkflowComment("CLAIM_HANDLER_COMMENT");
        item.CLAIM_HANDLER_COMPLETE_DATE = new Date();
        calculateClaimDuration(item.INCIDENT_DATE,new Date());
        break;
    
    case 'INVESTIGATE_CLAIM':  
        item.CLAIM_HANDLER_COMPLETE_DATE = null;
        item.CLAIM_DURATION = null;
        addWorkflowComment("CLAIM_HANDLER_COMMENT");
        break;         
    
    case 'RETURN':  
        addWorkflowComment("CLAIM_HANDLER_COMMENT");
        break;   
        
}

setStatusDetails();


function setStatusDetails() {
    
    var label = item.descriptor.workflowState;
    var color = "ee4444";
    
    switch(label) {
        
        case 'Completed':
        case 'Invalid Claim':
            color = "8fc844";
            break;  
        case 'Cost Analysis':
        case 'Clarification':
            color = "ffa600";
            break;
        case 'Investigation':
            color = "ee4444";
            break;       
        case 'Created':
            color = "c2cdd3";
            break;  
        
    }
    
    if(item.STATUS_LABEL !== label) item.STATUS_LABEL = label;
    if(item.STATUS_COLOR !== color) item.STATUS_COLOR = color;
    
} 


function reset() {

    item.CLAIM_HANDLER_COMPLETE_DATE = null;
    item.CLAIM_COST_COMPLETE_DATE = null;
    item.CLAIM_CLARIFICATION_COMPLETE_DATE = null;
    
    item.CLAIM_HANDLER_COMMENT = null;
    item.CLAIM_COSTING_COMMENT = null;
    item.CLAIM_CLARIFICATION_COMMENT = null;
    
    item.CLARIFICATION_LOG = null;
    
    item.COMPLETION_DATE = null;
    
}


function addWorkflowComment(field) {
    
   var comment = item.workflowActions[0].comments;
    
    if(comment !== null) {
        if(comment !== "") {
            item[field] = comment;
        }
    }
}

function appendToThread(field) {
    
    var comment = item.workflowActions[0].comments;
    
    if(comment !== null) {
        if(comment !== "") {
            
            var date   = new Date();
            var thread = "&lt;p&gt;" + comment + "&lt;br&gt;&lt;span style='font-size:10px;font-style:italic;color:#999'&gt;" + getUserName() + " (" + date.toDateString() + ")&lt;/span&gt;&lt;/p&gt;";
            
            if(item[field] !== null) thread += item[field];
            item[field] = thread;
            
        }
    }
}

function getUserName() {
    var usr = Security.loadUser(userID);
    return usr.lastName + ", " + usr.firstName;
}

function calculateClaimDuration(startDate, endDate) {

    if(startDate !== null && endDate !== null) {
        item.CLAIM_DURATION = Math.round((endDate.getTime() - startDate.getTime()) / (1000 * 3600 * 24)) + 1;
    }
}
