// This script is part of the app DESIGN REVIEWS available in the App Store
// last modification date: Nov 26, 2019

switch(customTransID) {
    
    case 'START':
        setMilestones();
        setOwner();
        if(item.TARGET_START_DATE === null) item.TARGET_START_DATE = new Date();
        break;
    
    case 'ACKNOWLEDGE':
        item.ACTUAL_START_DATE = new Date();
        break;
    
    case 'SUBMIT_FOR_REVIEW':
        item.ASSIGNEE_COMMENTS = item.workflowActions[0].comments;
        item.ASSIGNEE_ACTION_DATE = new Date();
        break;
    
    case 'FINISH_TASK':
        item.ASSIGNEE_COMMENTS = item.workflowActions[0].comments;
        item.ASSIGNEE_ACTION_DATE = new Date();
        item.ACTUAL_COMPLETION_DATE = new Date();
        updateParent();
        break;
     
    case 'RETURN_TO_ASSIGNEE':
        item.REVIEWER_COMMENTS = item.workflowActions[0].comments;
        item.REVIEWER_ACTION_DATE = new Date();
        break;
        
    case 'FINISH_TASK_2':
        item.REVIEWER_COMMENTS = item.workflowActions[0].comments;
        item.REVIEWER_ACTION_DATE = new Date();  
        item.ACTUAL_COMPLETION_DATE = new Date();  
        updateParent();
        break;
    
}


// set task owner matching design review coordinator
function setOwner() {
    
    var designReview = item.DESIGN_REVIEW;
    
    if(designReview !== null) {
        
        var coordinator = designReview.COORDINATOR;
        var userData    = coordinator.split(", ");
        var users       = Security.searchUsers({lastName:userData[0], firstName:userData[1]}); 
        
        if(users[0].id !== userID) {
            item.master.owner = Security.loadUser(users[0].id);
        }
    }
    
}


// set milestones based on target dates
function setMilestones() {
    
    var dateStart    = (item.TARGET_START_DATE === null) ? new Date() : item.TARGET_START_DATE;
    
    setMilestone("In Work",  "ENTER", dateStart, null, 0, 10, true);
    setMilestone("Complete", "ENTER", item.TARGET_COMPLETION_DATE, null, 0, 100, true);
  
    if(item.REVIEWER !== null) {
        setMilestone("Review",   "ENTER", item.TARGET_COMPLETION_DATE, null, 3, 80, true);
    }
    
}


// upon task completion transition related Design Review
function updateParent() {
    
    var parent = item.DESIGN_REVIEW;
    var countPending = 0;

    if(parent !== null)  {

        var children = parent.project.children;

        if(children === null) return;

        for(var i = children.length - 1; i >= 0; i--) {
           if(children[i].target.master.dmsID !== dmsID) {
               if(children[i].progress !== 100) {
                   countPending++;
               }
           }
        }

        if(countPending === 0) parent.performWorkflowTransitionByCustomID("ALL_TASKS_COMPLETED", "All tasks completed");
        parent.PENDING_TASKS_COUNT = countPending;

    }
    
}