// This script is part of the IDEA MANAGEMENT app available in the App Store
// Last modification date: Mar 24, 2024


var keys = Object.keys(item);

setTotalScore();
updateReferences();


function setTotalScore() {

    var total = 0;
    var count = 0;
    var label = item.SCORE_LABEL;

    for(var i = 0; i < keys.length; i++) {
               
        if(keys[i].indexOf('SCORE_') === 0) {
            if(keys[i].length === 7) {
        
                var value  = item[keys[i]];
                var number = (value === null) ? 0 : Number(value.substring(1,2));
                
                count++;
                total += number;
                
            }
        }
        
    }

    var level1 = 4 * count;
    var level2 = (2 * count) + 1;

         if(total <      1) label = 'No Assessment';
    else if(total < level2) label = 'Bad Idea';
    else if(total < level1) label = 'Good Idea';
                       else label = 'Great Idea';

    if(item.TOTAL_SCORE !== total) item.TOTAL_SCORE = total;
    if(item.SCORE_LABEL !== label) item.SCORE_LABEL = label;

}


function updateReferences() {

    updateRelatedPickListValue  ('RELATED_PRODUCT_LINE'    , 'PREVIOUS_RELATED_PRODUCT_LINE'   , 'IDEAS');
    updateRelatedPickListsValues('RELATED_PRODUCTS'        , 'PREVIOUS_RELATED_PRODUCTS'       , 'IDEAS');
    updateRelatedPickListsValues('RELATED_REQUIREMENTS'    , 'PREVIOUS_RELATED_REQUIREMENTS'   , 'IDEAS');
    updateRelatedPickListsValues('RELATED_CHANGE_REQUESTS' , 'PREVIOUS_RELATED_CHANGE_REQUESTS', 'IDEAS');

}
function updateRelatedPickListValue(fieldItemNew, fieldItemOld, fieldList) {
    
    if(keys.indexOf(fieldItemOld) < 0) return;

    var itemNew = item[fieldItemNew];
    var itemOld = item[fieldItemOld];
    
    if(itemNew !== itemOld) {

        if(itemNew !== null) {
            
            var itemId      = item.master.dmsID;
            var elements    = itemNew[fieldList];
            var add         = true;
            
            if(typeof elements !== 'undefined') {
                if(elements !== null) {

                    for(var i = 0; i < elements.length; i++) { 
                        if(elements[i].master.dmsID === itemId) {
                            add = false; 
                            continue;
                        }
                    }

                    if(add) elements.add(item);

                }
            }
            
        }
        
        if(itemOld !== null) {
            if(fieldList !== null ) {
                if(typeof itemOld[fieldList] !== 'undefined') {
                    if(itemOld[fieldList] !== null) {
                        itemOld[fieldList].remove(item);
                    }
                }
            }
        }
        
        item[fieldItemOld] = item[fieldItemNew];
        
    }
      
}



function updateRelatedPickListsValues(fieldItemsNew, fieldItemsOld, fieldList) {

    if(keys.indexOf(fieldItemsOld) < 0) return;
    
    var listNew = [];
    var listOld = [];
    
    for(var iNew = 0; iNew < item[fieldItemsNew].length; iNew++) {
            
        var isNew   = true;
        var elemNew = item[fieldItemsNew][iNew];
            
        for(var iOld = 0; iOld < item[fieldItemsOld].length; iOld++) {
            if(elemNew.master.dmsID === item[fieldItemsOld][iOld].master.dmsID) {
                isNew = false;
                break;
            }
        }
        
        if(isNew) {
            
            listNew.push(elemNew);            

            if(typeof fieldList !== 'undefined') {

                var elemListNew = elemNew[fieldList];

                if(typeof elemListNew !== 'undefined') {
                    if(elemListNew !== null) {
                        elemListNew.add(item);
                    }
                }

            }
        }
            
    }
    
    for(var iPrev = item[fieldItemsOld].length - 1; iPrev >= 0; iPrev--) {
            
        var keep     = false;
        var elemPrev = item[fieldItemsOld][iPrev];
            
        for(var iRef = 0; iRef < item[fieldItemsNew].length; iRef++) {
            if(elemPrev.master.dmsID === item[fieldItemsNew][iRef].master.dmsID) {
                keep = true;
                break;
            }
        }
        
        if(!keep) {

            if(typeof fieldList !== 'undefined') {

                var elemListPrev = elemPrev[fieldList];

                if(typeof elemListPrev !== 'undefined') {
                    if(elemListPrev !== null) {
                        elemListPrev.remove(item);
                    }
                }

            }

            listOld.push(elemPrev);
            
        }
            
    }    
    
   for(var i = 0; i < listNew.length; i++) item[fieldItemsOld].add(listNew[i]);
   for(var j = 0; j < listOld.length; j++) item[fieldItemsOld].remove(listOld[j]);
    
}