setDMSID();
setNumber();
setPDMData();
setFileFormat();
setClassSummary();
/* Uncomment the following line if classification values should be stored in given field to enable searching by classification values */
//storeClassificationValues();


function setDMSID() {

    if(item.DMS_ID !== dmsID.toString()) {
        item.DMS_ID = dmsID;
        item.PENDING_PACKAGES = [];
    }

}


function setNumber() {
    
    if(item.NUMBER !== null) return;

    var seq     = Sequencer.get("Items");
    var next    = seq.nextValue();
    var number  = ('00000000' + next).slice(-8);
    
    item.NUMBER = number;

}


function setPDMData() {
    
    if(item.PDM_ITEM_ID === null) return;
    
    var uom     = item.UNIT_OF_MEASURE;
    var length  = item.LENGTH;
    var width   = item.WIDTH;
    var height  = item.HEIGHT;
    
    switch(item.PDM_UNIT_OF_MEASURE) {
        
        case 'Each': uom = 'Each'; break;   
        
    }
    
    if(item.SIZE !== null) {
        
        var dimensions = item.SIZE.split('x');
        
                                    length = dimensions[0].trim();
        if(dimensions.length > 1)    width = dimensions[1].trim();
        if(dimensions.length > 2)   height = dimensions[2].trim();
        
    }
    
    if(item.TYPE === null) item.TYPE = 'Mechanical';
    if(item.UNIT_OF_MEASURE !== uom) item.UNIT_OF_MEASURE = uom;
    
    if(item.LENGTH !== length) item.LENGTH = length;
    if(item.WIDTH  !== width ) item.WIDTH  = width;
    if(item.HEIGHT !== height) item.HEIGHT = height;
    
}


function setFileFormat() {

    var format = '';
    
    if(item.PRIMARY_FILE_NAME !== null) {

        var filename = item.PRIMARY_FILE_NAME.split('.');
        var extension = filename[filename.length - 1].toLowerCase();

        switch(extension) {

            case 'ipt':
            case 'iam':
                format = 'Inventor';
                break;

            case 'sldprt':
            case 'sldasm':
                format = 'Solidworks';
                break;

            case 'catpart':
            case 'catproduct':
                format = 'CATIA';
                break;

        }

    }

    if(item.PRIMARY_FILE_FORMAT !== format) item.PRIMARY_FILE_FORMAT = format;

}


function setClassSummary() {

    var rootClass = '';
    var classPath = '';
    var className = '';

    if(Object.keys(item.classification).length > 0) {
        
        var path = item.classificationSection.getClassificationPath();

        if(path.length > 0) {
        
            rootClass = path[0];
            className = path[path.length - 1];
            classPath = rootClass;

            if(path.length > 1) {
                for(var i = 1; i < path.length; i++) {
                    classPath += ' / ' + path[i];
                }
            }
        
        }
    
    }

    if(item.TOP_LEVEL_CLASS !== rootClass) item.TOP_LEVEL_CLASS = rootClass;
    if(item.CLASS_PATH      !== classPath) item.CLASS_PATH      = classPath;
    if(item.CLASS_NAME      !== className) item.CLASS_NAME      = className;

}


function storeClassificationValues() {
    
    var classValues  = '';
    
    if(item.classification !== null) {
        for (var property in item.classification) {
            if (item.classification.hasOwnProperty(property)) {
                if (typeof item.classification[property] === 'object'){
                    classValues += property + ':' + item.classification[property].displayValue + ', ';
                }else{
                    classValues += property + ':' + item.classification[property] + ', ';
                }
            }
        }
    }
    
    if(item.CLASSIFICATION_VALUES !== classValues) item.CLASSIFICATION_VALUES = classValues;
    
}