switch(customTransID) {
    
    case 'APPROVE':
    case 'REACTIVATE':
        addMPNs();
        break;
    
    case 'RETURN_TO_DEFINITION_FOR_UPDATE':
    case 'SET_INACTIVE':
    case 'ARCHIVE_2':
        removeMPNs();
        break;
        
    case 'ARCHIVE_1':
    case 'ARCHIVE_3':
        item.deleteItem();
        break;
    
}

// Add to related item's grid and update sourcing information
function addMPNs() {
    
    for(var i = 0; i < item.grid.length; i++ ) addMPN(item.grid[i]);
    
}
function addMPN(gridRow) {
    
    var relItem = gridRow.REFERENCE_ITEM;
    
    if(gridRow.SET_PREFERRED === true) {
        for(var i = 0; i < relItem.grid.length; i++) {
            if(relItem.grid[i].PREFERRED === true) {
                relItem.grid[i].PREFERRED = false;
            }
        }
    }       
    
    var row = relItem.grid.addRow();
        row.MANUFACTURER_PN = item;
        row.MANUFACTURER = item.MANUFACTURER;
        row.VENDOR = item.VENDOR;
        row.PREFERRED = gridRow.SET_PREFERRED;
        row.UNIT_COST = item.UNIT_COST;
        row.LEAD_TIME = item.LEAD_TIME;
        row.MIN_ORDER_QTY = item.MIN_ORDER_QTY;
        row.MAX_ORDER_QTY = item.MAX_ORDER_QTY;
        row.COUNTRY = item.COUNTRY;
        row.LAST_UPDATE = new Date();


    if(gridRow.SET_PREFERRED === true) {
    
        relItem.MANUFACTURER_PN = item.MANUFACTURER_PN;
        relItem.MANUFACTURER    = item.MANUFACTURER;
        relItem.VENDOR          = item.VENDOR;
        relItem.UNIT_COST       = item.UNIT_COST;
        relItem.LEAD_TIME       = item.LEAD_TIME;
        
        if(item.ROHS              !== null) relItem.ROHS              = item.ROHS;
        if(item.REACH             !== null) relItem.REACH             = item.REACH;
        if(item.CONFLICT_MINERALS !== null) relItem.CONFLICT_MINERALS = item.CONFLICT_MINERALS;
        
    }
    
    updateItemSourcingMin(relItem, "UNIT_COST_MIN", "UNIT_COST");
    updateItemSourcingMin(relItem, "LEAD_TIME_MIN", "LEAD_TIME");
    updateItemSourcingMax(relItem, "UNIT_COST_MAX", "UNIT_COST");
    updateItemSourcingMax(relItem, "LEAD_TIME_MAX", "LEAD_TIME");
    
}
function updateItemSourcingMin(relItem, fieldIdItem, fieldIdMPN) {
    
    
    if((relItem[fieldIdItem] === null) || (relItem[fieldIdItem] > item[fieldIdMPN])) relItem[fieldIdItem] = item[fieldIdMPN];
    
}
function updateItemSourcingMax(relItem, fieldIdItem, fieldIdMPN) {
    
    
    if((relItem[fieldIdItem] === null) || (relItem[fieldIdItem] < item[fieldIdMPN])) relItem[fieldIdItem] = item[fieldIdMPN];
    
}


// Remove from related item's grid and update sourcing information
function removeMPNs() {
    
    for(var i = 0; i < item.grid.length; i++ ) removeMPN(item.grid[i]);
    
}
function removeMPN(gridRow) {
    
    var relItem     = gridRow.REFERENCE_ITEM;
    var results     = [null, null, null, null];
    var isPreferred = false;
    
    for(var i = relItem.grid.length - 1; i >= 0; i--) {
        var row = relItem.grid[i];
        if(row.MANUFACTURER_PN === item) {
            isPreferred = row.PREFERRED;
            row.remove();
        } else {
            if((results[0] === null ) || (results[0] > row.UNIT_COST)) results[0] = row.UNIT_COST;
            if((results[1] === null ) || (results[1] < row.UNIT_COST)) results[1] = row.UNIT_COST;
            if((results[2] === null ) || (results[2] > row.LEAD_TIME)) results[2] = row.LEAD_TIME;
            if((results[3] === null ) || (results[3] < row.LEAD_TIME)) results[3] = row.LEAD_TIME;
        }
    }
    
    if(relItem.UNIT_COST_MIN !== results[0]) relItem.UNIT_COST_MIN = results[0];
    if(relItem.UNIT_COST_MAX !== results[1]) relItem.UNIT_COST_MAX = results[1];
    if(relItem.LEAD_TIME_MIN !== results[2]) relItem.LEAD_TIME_MIN = results[2];
    if(relItem.LEAD_TIME_MAX !== results[3]) relItem.LEAD_TIME_MAX = results[3];
    
    if(isPreferred) {
        relItem.MANUFACTURER_PN = null;
        relItem.MANUFACTURER    = null;
        relItem.VENDOR          = null;
        relItem.UNIT_COST       = null;
        relItem.LEAD_TIME       = null;
    }
    
}