// This script is part of the QUALITY MANAGEMENT app available in the App Store
// Last modification date: Mar 9, 2021


switch(customTransID){

    case 'NEW':
        item.CREATION_DATE = new Date();
        item.CREATED_BY = getUserName();
        reset();
        break;
        
    case 'SUBMIT_FOR_REVIEW':
        item.CREATION_COMMENTS = item.workflowActions[0].comments;
        break;
     
    case 'APPROVE_FOR_DISPOSITION':
        item.REVIEW_DATE = new Date();
        item.REVIEWED_BY = getUserName();
        item.REVIEW_COMMENTS = item.workflowActions[0].comments;
        break;
        
    case 'RETURN_TO_REVIEW':
        item.REVIEW_DATE = null;
        item.REVIEWED_BY = null;
        item.REVIEW_COMMENTS = null;
        break;
        
    case 'CLOSE':
    case 'INITIATE_CAPA':
        addToSupplier(); 
        item.DISPOSITION_DATE = new Date();
        item.DISPOSITION_APPROVED_BY = getUserName();
        item.DISPOSITION_COMMENTS = item.workflowActions[0].comments;
        if(customTransID === 'CLOSE') item.CLOSING_DATE = new Date(); else initCAPA();
        break; 
        
    case 'CAPA_COMPLETE':
        item.CLOSING_DATE = new Date();
        break;        
}


function reset() {
    
    if(item.SPAWNED_BY !== null) {
        if(item.SPAWNED_BY.SPAWNED_NON_CONFORMANCE !== null) {
            if(item.SPAWNED_BY.SPAWNED_NON_CONFORMANCE !== item) {
                item.SPAWNED_BY = null;
            }
        }
    }
    
    item.REVIEW_DATE = null;
    item.REVIEWED_BY = null;
    item.REVIEW_COMMENTS = null;
    
    item.DISPOSITION_DATE = null;
    item.DISPOSITION_APPROVED_BY = null;
    item.DISPOSITION_COMMENTS = null;
    
    item.CLOSING_DATE = null;
    item.RELATED_CAPA = null;
    
}
    

function addToSupplier() {
    
    if(item.RELATED_SUPPLIER === null) return;
    
    var row = item.RELATED_SUPPLIER.grid.addRow();
        row.NCR = item;
        row.ITEM = item.NONCONFORMING_ITEM;
        row.DATE = new Date();
    
}


function initCAPA() {
    
    if (item.RELATED_CAPA !== null) return;
    
    
    var newItem = createItem('WS_CORRECTIVE_PREVENTATIVE_ACTIONS');
        newItem.SPAWNED_BY_NCR = item;
        newItem.RELATED_SUPPLIER = item.RELATED_SUPPLIER;
        newItem.PROBLEM_STATEMENT = item.DESCRIPTION;
        newItem.TITLE = 'CAPA for ' + item.NUMBER;
        
    item.RELATED_CAPA = newItem;
    
}