// This script is part of the NEW PRODUCT INTRODUCTION app available in the App Store
// Last modification date: Feb 3, 2021


var progress = (item.PERCENT_COMPLETE === null) ? 0 : item.PERCENT_COMPLETE;

setMilestone("In Work",   "ENTER", item.PLANNED_START_DATE, null, 0, progress, true);
setMilestone("Completed", "ENTER", item.PLANNED_COMPLETION_DATE, null, 0, 100, true);

setUserAccounts();
updateParent();


// Create, update or delete defined milestone
function setMilestone(name, event, date, offset, threshold, progress, deleteIfEmpty) {
    
    var milestoneIndex  = -1;
    var offsetSat       = (date === null) ? 2 : 2;
    var offsetSun       = (date === null) ? 1 : 1;
    var targetDate      = new Date();
    
    if(         date !== null) { targetDate = date; } else if(offset !== null) { targetDate.setDate(targetDate.getDate() + offset); } 
    if(        event === null) event         = "ENTER";
    if(    threshold === null) threshold     = 0;
    if(deleteIfEmpty === null) deleteIfEmpty = true;
    
    var day = targetDate.getDay();
    
         if(day === 0) targetDate.setDate(targetDate.getDate() + offsetSun);
    else if(day === 6) targetDate.setDate(targetDate.getDate() + offsetSat);

    for(var i = 0; i < item.milestones.length; i++) {
        if(item.milestones[i].workflowStateName == name) {
            if(item.milestones[i].milestoneType == event) {
                milestoneIndex = i;
                break;
            }
        }
    }
    
    if(deleteIfEmpty) {
        if (date === null) {
            if (offset === null) {
                if(milestoneIndex > -1) {
                    item.milestones.splice(milestoneIndex, 1);
                }
                return;
            }
        }
    }

    if(milestoneIndex == -1) {
        
		var milestone = item.addMilestone();
		    milestone.setWorkflowState(name);
		    milestone.milestoneType = event;
		    milestone.milestoneDate = targetDate;
		    milestone.warnThreshold = threshold;
            milestone.progress      = progress;
        
    } else {
        
        item.milestones[milestoneIndex].milestoneDate = targetDate;
        item.milestones[milestoneIndex].progress = progress;
        
    }
    
}


// Set user accounts based on selected team (member)
function setUserAccounts() {
    
    var teamLeader  = item.TEAM_LEADER;
    var assignee    = item.ASSIGNEE;
    
    if(assignee !== null) {
        var userName = assignee.USER_ACCOUNT;
        if(item.ASSIGNEE_USER !== userName) item.ASSIGNEE_USER = userName;
    }
    
    if(item.TEAM_LEADER_USER !== teamLeader) item.TEAM_LEADER_USER = teamLeader;
    
}


// update project grid tab in case of new assignment
function updateParent() {
 
    if(item.PROJECT === null) return;
    
    if(item.TEAM === item.PLAN_TEAM) {
        if(item.ASSIGNEE === item.PLAN_ASSIGNEE) {
            if(item.REVIEWER === item.PLAN_REVIEWER) {
                return;
            }
        }
    }
    
    for(var i = 0; i < item.PROJECT.grid.length; i++) {
    
        var row = item.PROJECT.grid[i];
        
        if(row.TASK === item) {
        
            if(row.TEAM         !== item.TEAM       ) { row.TEAM        = item.TEAM;        item.PLAN_TEAM     = item.TEAM;         }
            if(row.TEAM_LEADER  !== item.TEAM_LEADER) { row.TEAM_LEADER = item.TEAM_LEADER; }
            if(row.ASSIGNEE     !== item.ASSIGNEE   ) { row.ASSIGNEE    = item.ASSIGNEE;    item.PLAN_ASSIGNEE = item.ASSIGNEE;     }
            if(row.REVIEWER     !== item.REVIEWER   ) { row.REVIEWER    = item.REVIEWER;    item.PLAN_REVIEWER = item.REVIEWER;     }
            
        }
        
        
    }
    
}