// This script is part of the QUALITY MANAGEMENT app available in the App Store
// Last modification date: Mar 3, 2021


/* Columns: lot min, lot max, GI, GII, GIII, S1, S2, S3, S4 */
var sampleSizeCodes = [
    [2,8,"A","A","B","A","A","A","A"],
    [9,15,"A","B","C","A","A","A","A"],
    [16,25,"B","C","D","A","A","B","B"],
    [26,50,"C","D","E","A","B","B","C"],
    [51,90,"C","E","F","B","B","C","C"],
    [91,150,"D","F","G","B","B","C","D"],
    [151,280,"F","G","H","B","C","D","E"],
    [281,500,"F","H","J","B","C","D","E"],
    [501,1200,"G","J","K","C","C","E","F"],
    [1201,3200,"H","K","L","C","D","E","G"],
    [3201,10000,"J","L","M","C","D","F","G"],
    [10001,35000,"K","M","N","C","D","F","H"],
    [35001,150000,"L","N","P","D","E","G","J"],
    [150001,500000,"M","P","Q","D","E","G","J"],
    [500001,1000000000,"N","Q","R","D","E","H","K"]
];

var singleNormal = {
    
    'A' : {"n":2,"row":[{"aql":6.5,"ac":0},{"aql":10,"ac":1},{"aql":15,"ac":1},{"aql":25,"ac":1},{"aql":40,"ac":2},{"aql":65,"ac":3},{"aql":100,"ac":5},{"aql":150,"ac":7},{"aql":250,"ac":10},{"aql":400,"ac":14},{"aql":650,"ac":21},{"aql":1000,"ac":30}]},
    'B' : {"n":3,"row":[{"aql":4.0,"ac":0},{"aql":6.5,"ac":0},{"aql":10,"ac":1},{"aql":15,"ac":1},{"aql":25,"ac":2},{"aql":40,"ac":3},{"aql":65,"ac":5},{"aql":100,"ac":7},{"aql":150,"ac":10},{"aql":250,"ac":14},{"aql":400,"ac":21},{"aql":650,"ac":30},{"aql":1000,"ac":44}]},
    'C' : {"n":5,"row":[{"aql":2.5,"ac":0},{"aql":4.0,"ac":0},{"aql":6.5,"ac":1},{"aql":10,"ac":1},{"aql":15,"ac":2},{"aql":25,"ac":3},{"aql":40,"ac":5},{"aql":65,"ac":7},{"aql":100,"ac":10},{"aql":150,"ac":14},{"aql":250,"ac":21},{"aql":400,"ac":30},{"aql":650,"ac":44}]},
    'D' : {"n":8,"row":[{"aql":1.5,"ac":0},{"aql":2.5,"ac":0},{"aql":4.0,"ac":1},{"aql":6.5,"ac":1},{"aql":10,"ac":2},{"aql":15,"ac":3},{"aql":25,"ac":5},{"aql":40,"ac":7},{"aql":65,"ac":10},{"aql":100,"ac":14},{"aql":150,"ac":21},{"aql":250,"ac":30},{"aql":400,"ac":44}]},
    'E' : {"n":13,"row":[{"aql":1.0,"ac":0},{"aql":1.5,"ac":0},{"aql":2.5,"ac":1},{"aql":4.0,"ac":1},{"aql":6.5,"ac":2},{"aql":10,"ac":3},{"aql":15,"ac":5},{"aql":25,"ac":7},{"aql":40,"ac":10},{"aql":65,"ac":14},{"aql":100,"ac":21},{"aql":150,"ac":30},{"aql":250,"ac":44}]},
    'F' : {"n":20,"row":[{"aql":0.65,"ac":0},{"aql":1.0,"ac":0},{"aql":1.5,"ac":1},{"aql":2.5,"ac":1},{"aql":4.0,"ac":2},{"aql":6.5,"ac":3},{"aql":10,"ac":5},{"aql":15,"ac":7},{"aql":25,"ac":10},{"aql":40,"ac":14},{"aql":65,"ac":21}]},
    'G' : {"n":32,"row":[{"aql":0.40,"ac":0},{"aql":0.65,"ac":0},{"aql":1.0,"ac":1},{"aql":1.5,"ac":1},{"aql":2.5,"ac":2},{"aql":4.0,"ac":3},{"aql":6.5,"ac":5},{"aql":10,"ac":7},{"aql":15,"ac":10},{"aql":25,"ac":14},{"aql":40,"ac":21}]},
    'H' : {"n":50,"row":[{"aql":0.25,"ac":0},{"aql":0.40,"ac":0},{"aql":0.65,"ac":1},{"aql":1.0,"ac":1},{"aql":1.5,"ac":2},{"aql":2.5,"ac":3},{"aql":4.0,"ac":5},{"aql":6.5,"ac":7},{"aql":10,"ac":10},{"aql":15,"ac":14},{"aql":25,"ac":21}]},
    'J' : {"n":80,"row":[{"aql":0.15,"ac":0},{"aql":0.25,"ac":0},{"aql":0.40,"ac":1},{"aql":0.65,"ac":1},{"aql":1.0,"ac":2},{"aql":1.5,"ac":3},{"aql":2.5,"ac":5},{"aql":4.0,"ac":7},{"aql":6.5,"ac":10},{"aql":10,"ac":14},{"aql":15,"ac":21}]},
    'K' : {"n":125,"row":[{"aql":0.10,"ac":0},{"aql":0.15,"ac":0},{"aql":0.25,"ac":1},{"aql":0.40,"ac":1},{"aql":0.65,"ac":2},{"aql":1.0,"ac":3},{"aql":1.5,"ac":5},{"aql":2.5,"ac":7},{"aql":4.0,"ac":10},{"aql":6.5,"ac":14},{"aql":10,"ac":21}]},
    'L' : {"n":200,"row":[{"aql":0.065,"ac":0},{"aql":0.10,"ac":0},{"aql":0.15,"ac":1},{"aql":0.25,"ac":1},{"aql":0.40,"ac":2},{"aql":0.65,"ac":3},{"aql":1.0,"ac":5},{"aql":1.5,"ac":7},{"aql":2.5,"ac":10},{"aql":4.0,"ac":14},{"aql":6.5,"ac":21}]},
    'M' : {"n":315,"row":[{"aql":0.040,"ac":0},{"aql":0.065,"ac":0},{"aql":0.10,"ac":1},{"aql":0.15,"ac":1},{"aql":0.25,"ac":2},{"aql":0.40,"ac":3},{"aql":0.65,"ac":5},{"aql":1.0,"ac":7},{"aql":1.5,"ac":10},{"aql":2.5,"ac":14},{"aql":4.0,"ac":21}]},
    'N' : {"n":500,"row":[{"aql":0.025,"ac":0},{"aql":0.040,"ac":0},{"aql":0.065,"ac":1},{"aql":0.10,"ac":1},{"aql":0.15,"ac":2},{"aql":0.25,"ac":3},{"aql":0.40,"ac":5},{"aql":0.65,"ac":7},{"aql":1.0,"ac":10},{"aql":1.5,"ac":14},{"aql":2.5,"ac":21}]},
    'P' : {"n":800,"row":[{"aql":0.015,"ac":0},{"aql":0.025,"ac":0},{"aql":0.040,"ac":1},{"aql":0.065,"ac":1},{"aql":0.10,"ac":2},{"aql":0.15,"ac":3},{"aql":0.25,"ac":5},{"aql":0.40,"ac":7},{"aql":0.65,"ac":10},{"aql":1.0,"ac":14},{"aql":1.5,"ac":21}]},
    'Q' : {"n":800,"row":[{"aql":0.010,"ac":0},{"aql":0.015,"ac":0},{"aql":0.025,"ac":1},{"aql":0.040,"ac":1},{"aql":0.065,"ac":2},{"aql":0.10,"ac":3},{"aql":0.15,"ac":5},{"aql":0.25,"ac":7},{"aql":0.40,"ac":10},{"aql":0.65,"ac":14},{"aql":1.0,"ac":21}]},
    'R' : {"n":2000,"row":[{"aql":0.010,"ac":0},{"aql":0.015,"ac":0},{"aql":0.025,"ac":1},{"aql":0.040,"ac":2},{"aql":0.065,"ac":3},{"aql":0.10,"ac":5},{"aql":0.15,"ac":7},{"aql":0.25,"ac":10},{"aql":0.40,"ac":14},{"aql":0.65,"ac":21}]}
    
}


var aql         = item.AQL;
var lotSize     = item.LOT_SIZE;
var level       = item.INSPECTION_LEVEL;
var sampleCode  = getSampleSizeCode();
var sampleSize  = getSampleSizeSingleNormal();
var maxFailures = getMaxFailuresSingleNormal();


if(item.SAMPLE_SIZE_CODE !== sampleCode ) item.SAMPLE_SIZE_CODE = sampleCode;
if(item.SAMPLES_SIZE     !== sampleSize ) item.SAMPLES_SIZE     = sampleSize;
if(item.MAXIMUM_FAILURES !== maxFailures) item.MAXIMUM_FAILURES = maxFailures;


updateInspectedItem();


function getSampleSizeCode() {
    
    if(lotSize === null) return null;
    if(level   === null) return null;
    
    var result = null;
    
    for (i = 0; i < sampleSizeCodes.length; i++) {
        if ((sampleSizeCodes[i][0] <= lotSize) && (lotSize <= sampleSizeCodes[i][1])) {
            
            switch(level) {
                    
                case 'General Inspection I'  : result = sampleSizeCodes[i][2]; break;
                case 'General Inspection II' : result = sampleSizeCodes[i][3]; break;
                case 'General Inspection III': result = sampleSizeCodes[i][4]; break;
                case 'Special Inspection 1'  : result = sampleSizeCodes[i][5]; break;
                case 'Special Inspection 2'  : result = sampleSizeCodes[i][6]; break;
                case 'Special Inspection 3'  : result = sampleSizeCodes[i][7]; break;
                case 'Special Inspection 4'  : result = sampleSizeCodes[i][8]; break;
                    
            }
            
            break;
            
        }
    }
    
    return result;
    
}
function getSampleSizeSingleNormal() {
    
    if(sampleCode === null) return null;
    
    return(singleNormal[sampleCode].n);
    
}
function getMaxFailuresSingleNormal() {
    
    if(aql        === null) return null;
    if(sampleCode === null) return null;
    
    var row = singleNormal[sampleCode].row;
    for (i = 0; i < row.length; i++) {
        var cell = row[i];
        if (aql <= cell.aql) {
            return(cell.ac);        // normal cases
        }
    }
    if (aql <= 150) {               // ugly cases
        return(30);
    } else {
        return(44);
    }
    
}

function updateInspectedItem() {
    
    if(item.INSPECTED_ITEM === item.PREVIOUS_ITEM) return;
            
    var itemId      = item.master.dmsID;
    var elements    = item.INSPECTED_ITEM.QIPS;
    var add         = true;
            
    for(var i = 0; i < elements.length; i++) { 
        if(elements[i].master.dmsID === itemId) {
            add = false; 
            continue;
        }
    }

    if(add) elements.add(item);
            
    if(item.PREVIOUS_ITEM !== null) item.PREVIOUS_ITEM.QIPS.remove(item);
    
    item.PREVIOUS_ITEM = item.INSPECTED_ITEM;
    
}
    