// This script is part of the QUALITY MANAGEMENT app available in the App Store
// Last modification date: Mar 9, 2021


copyMeasurements();
setMilestone('Closed', 'ENTER', item.DEADLINE, 3, 100, true);


function copyMeasurements() {
    
    if(item.RELATED_QIP === item.PREVIOUS_QIP) return;
    
    item.grid.clear();
    
    for(var i = 0; i < item.RELATED_QIP.grid.length; i++) {
     
        var row = item.grid.addRow();
            row.REFERENCE           = item.RELATED_QIP.grid[i].REFERENCE;
            row.MEASUREMENT_DEVICE  = item.RELATED_QIP.grid[i].MEASUREMENT_DEVICE;
            row.UNITS               = item.RELATED_QIP.grid[i].UNITS;
            row.NOMINAL             = item.RELATED_QIP.grid[i].NOMINAL;
            row.TOLERANCE           = item.RELATED_QIP.grid[i].TOLERANCE;
        
    }
    
    item.PREVIOUS_QIP = item.RELATED_QIP;
}


function setMilestone(name, event, date, threshold, progress, deleteIfEmpty) {
    
    var milestoneIndex = -1;
    var targetDate     = new Date();
    
    if(         date !== null) targetDate    = date;
    if(        event === null) event         = "ENTER";
    if(    threshold === null) threshold     = 0;
    if(deleteIfEmpty === null) deleteIfEmpty = true;
    
    var day = targetDate.getDay();
    
         if(day === 0) targetDate.setDate(targetDate.getDate() + 1);
    else if(day === 6) targetDate.setDate(targetDate.getDate() + 2);

    for(var i = 0; i < item.milestones.length; i++) {
        if(item.milestones[i].workflowStateName == name) {
            if(item.milestones[i].milestoneType == event) {
                milestoneIndex = i;
                break;
            }
        }
    }
    
    if(deleteIfEmpty) {
        if (date === null) {
            if(milestoneIndex > -1) {
                item.milestones.splice(milestoneIndex, 1);
            }
            return;
        }
    }

    if(milestoneIndex == -1) {
        
		var milestone = item.addMilestone();
		    milestone.setWorkflowState(name);
		    milestone.milestoneType = event;
		    milestone.milestoneDate = targetDate;
		    milestone.warnThreshold = threshold;
            milestone.progress = progress;
        
    } else {
        
        item.milestones[milestoneIndex].milestoneDate = targetDate;
        item.milestones[milestoneIndex].progress = progress;
        
    }
    
}