// This script is part of the REQUIREMENTS MANAGEMENT app available in the App Store
// Last modification date: Mar 30, 2023


switch(customTransID) {

    case "CREATE":
        setNumber();
        setApprovers();
        break;

    case "APPROVE":
    case "REQUEST_EXTERNAL_REVIEW":
        item.APPROVAL_DATE_INTERNAL_REVIEW = new Date();
        item.INTERNAL_APPROVER = getUserName();
        item.COMMENTS_INTERNAL_REVIEW = item.workflowActions[0].comments;
        break;


    case "EXTERNAL_APPROVAL":
        item.APPROVAL_DATE_EXTERNAL_REVIEW = new Date();
        item.EXTERNAL_APPROVER = getUserName();
        item.COMMENTS_EXTERNAL_REVIEW = item.workflowActions[0].comments;
        break;

}


function setNumber() {

    var prefix  = "RA-";
    var seq     = Sequencer.get('Requirement Approvals');
    var next    = seq.nextValue();
    var number  = ('000000' + next).slice(-6);
	    
    item.ID = prefix + number;

}


function setApprovers() {

    if(item.REQUIREMENT_SPECIFICATION === null) return;

    if(item.INTERNAL_APPROVERS.length === 0) {
        for(var i = 0; i < item.REQUIREMENT_SPECIFICATION.INTERNAL_APPROVERS.length; i++) item.INTERNAL_APPROVERS.add(item.REQUIREMENT_SPECIFICATION.INTERNAL_APPROVERS[i]);
    }
    if(item.EXTERNAL_APPROVERS.length === 0) {
        for(var j = 0; j < item.REQUIREMENT_SPECIFICATION.EXTERNAL_APPROVERS.length; j++) item.EXTERNAL_APPROVERS.add(item.REQUIREMENT_SPECIFICATION.EXTERNAL_APPROVERS[j]);
    }
    
}


function getUserName() {
    var usr = Security.loadUser(userID);
    return usr.lastName + ", " + usr.firstName;
}