// This script is part of the REQUIREMENTS MANAGEMENT app available in the App Store
// Last modification date: Sep 24, 2021


setMilestone("Internal Review", "ENTER", item.TARGET_DATE_INTERNAL_REVIEW, 0, 60, true);
setMilestone("External Review", "ENTER", item.TARGET_DATE_EXTERNAL_REVIEW, 0, 80, true);


function setMilestone(name, event, date, threshold, progress, deleteIfEmpty) {
    
    var milestoneIndex = -1;
    var targetDate     = new Date();
    
    if(         date !== null) targetDate    = date;
    if(        event === null) event         = "ENTER";
    if(    threshold === null) threshold     = 0;
    if(deleteIfEmpty === null) deleteIfEmpty = true;
    
    var day = targetDate.getDay();
    
         if(day === 0) targetDate.setDate(targetDate.getDate() + 1);
    else if(day === 6) targetDate.setDate(targetDate.getDate() + 2);

    for(var i = 0; i < item.milestones.length; i++) {
        if(item.milestones[i].workflowStateName == name) {
            if(item.milestones[i].milestoneType == event) {
                milestoneIndex = i;
                break;
            }
        }
    }
    
    if(deleteIfEmpty) {
        if (date === null) {
            if(milestoneIndex > -1) {
                item.milestones.splice(milestoneIndex, 1);
            }
            return;
        }
    }

    if(milestoneIndex == -1) {
        
		var milestone = item.addMilestone();
		    milestone.setWorkflowState(name);
		    milestone.milestoneType = event;
		    milestone.milestoneDate = targetDate;
		    milestone.warnThreshold = threshold;
            milestone.progress = progress;
        
    } else {
        
        item.milestones[milestoneIndex].milestoneDate = targetDate;
        item.milestones[milestoneIndex].progress = progress;
        
    }
    
}