// This script is part of the REQUIREMENTS MANAGEMENT app available in the App Store
// Last modification date: Mar 21, 2023


var prefix = '';   // set custom prefix for new Requirement Specifications


reset();
setNumber();
setOwnership();
createTopLevelRequirement();


function setNumber() {

    var seq     = Sequencer.get('Requirement Specifications');
    var next    = seq.nextValue();
    var number  = ('0000' + next).slice(-4);
	    
    item.ID = prefix + number;

}


function reset() {
    
    item.REQUIREMENTS_COUNTER = 0;
    item.grid.clear();
    
}


function setOwnership() {
    
    if(item.GROUP_NAME === null) return;
    if(item.GROUP_NAME === "") return;
    
    var group = Security.loadGroup(item.GROUP_NAME);
    
    if(group !== null) item.master.groupAdditionalOwners.push(group);
    
}


function createTopLevelRequirement() {
    
    var req = createItem('WS_REQUIREMENTS');
        req.REQUIREMENT_SPECIFICATION = item;
        req.TITLE = 'Top Level Requirement';
        
    item.TOP_LEVEL_REQUIREMENT = req;
    
}