// This script is part of the REQUIREMENTS MANAGEMENT app available in the App Store
// Last modification date: May 3, 2023


reset();
setNumber();
setOwnership();
updateValidationProcess();


function reset() {

    item.grid.clear();

    if(item.TEST_RESULT !== null) item.TEST_RESULT  = null;
    if(item.TEST_DATE   !== null) item.TEST_DATE    = null;
    if(item.TEST        !== null) item.TEST         = null;

}


function setNumber() {

    if(item.ID !== null) return;

    var specID  = item.SPECIFICATION_ID;
    var counter = item.REQUIREMENT_SPECIFICATION.REQUIREMENTS_COUNTER;
    var number  = ('000' + counter).slice(-3);
	    
    item.ID = specID + '.' + number;
    item.REQUIREMENT_SPECIFICATION.REQUIREMENTS_COUNTER = counter + 1;

}


function setOwnership() {
    
    if(item.REQUIREMENT_SPECIFICATION === null) return;
    if(item.REQUIREMENT_SPECIFICATION.GROUP_NAME === null) return;
    if(item.REQUIREMENT_SPECIFICATION.GROUP_NAME === "") return;
    
    var group = Security.loadGroup(item.REQUIREMENT_SPECIFICATION.GROUP_NAME);
    
    if(group !== null) item.master.groupAdditionalOwners.push(group);
    
}