// This script is part of the SUPPLIER COLLABORATION app available in the App Store
// Last modification date: Jun 26, 2023


switch(customTransID) {
    
    case 'START':
       setMilestone('Completed', 'ENTER', item.TARGET_DATE, 0, 100, true);
       grantSupplierAccess(item, item.PACKAGE);
       break;

    case 'CONFIRM_DELIVERABLE':
        item.COMMENTS = item.workflowActions[0].comments;
        item.CONFIRMED_DATE = new Date();
        break;

   case 'SUBMIT_DELIVERABLE_1':
   case 'SUBMIT_DELIVERABLE_2':
   case 'SET_COMPLETE':
       item.DATE_SUBMITTED = new Date();
       item.SUBMITTED_BY = getUserName();
       item.SUBMIT_COMMENTS = item.workflowActions[0].comments;
       updatePackage();
       break;
       
}


function updatePackage() {

    if(item.PACKAGE === null) return;

    var packageTasks    = item.PACKAGE.project.children;
    var countTasks      = 0;
    var nextTask        = null;
    var nextDate        = new Date();
    
    nextDate.setDate(nextDate.getDate() + 10000);
        
    for(var i = packageTasks.length - 1; i >= 0; i--) {
        
        var elemTask = packageTasks[i].target;

        if(elemTask.descriptor.workflowState !== 'Completed') {
            countTasks++;
            if(elemTask.TARGET_DATE === null) {
                if(nextTask === null) { nextTask = elemTask; }
            } else if(elemTask.TARGET_DATE.getTime() < nextDate.getTime()) nextTask = elemTask;
        }

    }

    if(nextTask === null) item.PACKAGE.NEXT_DELIVERABLE_TARGET_DATE = null;

    item.PACKAGE.PENDING_DELIVERABLES = countTasks;
    item.PACKAGE.NEXT_DELIVERABLE = nextTask;

}