// This script is part of the SUPPLIER COLLABORATION app available in the App Store
// Last modification date: Mar 30, 2023


switch(customTransID) {
    
    case 'START':
        reset();
        item.STEP = 1;    
        break;

    case 'SUBMIT':
        item.SUBMITTED_BY = getUserName();
        item.SUBMITTAL_DATE = new Date();
        item.SUBMITTAL_COMMENTS = item.workflowActions[0].comments;
        setMilestone('Analysis', 'EXIT', item.RESPONSE_EXPECTED_BY, 0, 25, true);
        setOwner();
        updatePackage();
        item.STEP = 2;
        break;

    case 'RETURN':
        item.STEP = 1;    
        break;

    case 'REQUEST_TECHNICAL_REVIEW':
    case 'INITIATE_CORRECTIVE_ACTIONS':
        item.STEP = 3;
        break;

    case 'RETURN_RESPOND':
        item.STEP = 2;
        break;

    case 'CLOSE_1':
    case 'CLOSE_2':
    case 'CLOSE_3':
        resetPackage();
        item.STEP = 4;
        break;
    
}



function reset() {
    
    var seq = new Sequencer('Supplier Proposals');
    
    item.NUMBER = prefixSP + ('000000' + seq.nextValue().toString()).slice(-6);

    item.SUBMITTED_BY       = null;
    item.SUBMITTAL_DATE     = null;
    item.SUBMITTAL_COMMENTS = null;

    item.PROBLEM_REPORT = null;
    item.CHANGE_REQUEST = null;
    item.CAPA           = null;
    
    item.TECHNICIAN         = null;
    item.REVIEW_COMMENTS    = null;

}


function setOwner() {
    
	if(item.PACKAGE_REQUESTOR !== null) {
		
	    var userSelected    = item.PACKAGE_REQUESTOR.split(",");
	    var lastName        = userSelected[0].trim();
	    var firstName       = userSelected[1].trim();
	    var user            = Security.searchUsers({lastName:lastName, firstName:firstName}); 
		            
	    if(user !== null) {
	        var userId = user[0].id;
	        if(item.master.owner.id !== userId) {
                item.master.additionalOwners.push(Security.loadUser(userId));
	        }
	    }
		    
    }
    
}


function updatePackage() {
    
    if(item.IMPACTED_PACKAGE === null) return;
    
    var elemPackage = item.IMPACTED_PACKAGE;

    elemPackage.PENDING_SUPPLIER_PROPOSALS.add(item);

    if(item.DELIVERY_ON_HOLD  === null) return;
    if(item.DELIVERY_ON_HOLD  === 'No') return;
    
    var transitionId = 'SET_ON_HOLD_BY_SP_';
    
    switch(elemPackage.descriptor.workflowState) {
        
        case 'Submitted' : transitionId += '1'; break;
        case 'Confirmed' : transitionId += '2'; break;
        case 'Processing': transitionId += '3'; break;
        
        default : transitionId = '';
        
    }
    
    if(transitionId !== '') {
        elemPackage.performWorkflowTransitionByCustomID(transitionId, 'Set on hold by SCR');
        elemPackage.STEP = 6;
        elemPackage.ON_HOLD_SET_BY = getUserName();
        elemPackage.ON_HOLD_DATE = new Date();
        elemPackage.ON_HOLD_COMMENTS = 'Set on hold by SP: ' + item.workflowActions[0].comments;
        elemPackage.WORKFLOW_STATUS = 'On Hold';
    }
    
}


function resetPackage() {

    var elemPackage = item.IMPACTED_PACKAGE;
    
    if(elemPackage === null) return;
    
    elemPackage.PENDING_SUPPLIER_PROPOSALS.remove(item);
    
}