switch(customTransID){

    case 'CREATE':
        reset();
        break;

    case 'INITIATE_AUDIT_1':
    case 'INITIATE_AUDIT_2':
    case 'INITIATE_AUDIT_3':
        initAudit(); 
        break;

    case 'AUDIT_COMPLETE':
        item.REVIEW_TEAM_HAS_APPROVED.clear();
        setApprovers('REVIEW_TEAM', 'REVIEW_TEAM_REMAINING');
        setDates();
        break;

    case 'APPROVE':
        saveApproval('REVIEW_TEAM_HAS_APPROVED', 'REVIEW_TEAM_REMAINING', 'UPON_FINAL_APPROVAL', 'Final approval by team');
        break; 
        
}


// Clear read-only fields
function reset() {
    
    item.LAST = null;
    item.NEXT = null;
    
    item.AUDIT_IN_PROGRESS = null;
    item.LAST_AUDIT_COMPLETED = null;
    item.PREVIOUS_AUDITS.clear();
    item.REVIEW_TEAM_HAS_APPROVED.clear();
    item.REVIEW_TEAM_REMAINING.clear();
    
    item.grid.clear();
    
}


// Initiate new Audit
function initAudit() {
    
    var newItem = createItem('WS_AUDITS');
        newItem.SUPPLIER = item.NAME;
        newItem.DUE_DATE = item.NEXT;
            
    item.AUDIT_IN_PROGRESS = newItem;
    
}


// Set list of remaining approvers
function setApprovers(fieldIdApprovers, fieldIdRemaining) {
    
    item[fieldIdRemaining].clear();
    
    for(var i = 0; i < item[fieldIdApprovers].length; i++) {
        item[fieldIdRemaining].add(item[fieldIdApprovers][i]);
    }
    
}


// Set Last & Next Evaluation dates
function setDates() {
    
    var next  = new Date();
    var cycle = item.CYCLE_MONTHS;
    
    if(cycle === null) cycle = 12;
    
    item.LAST = new Date();
    item.NEXT = next.setDate(next.getMonth() + cycle);
    
}


// Save approval infomration and update last/next dates
function saveApproval(fieldIdHas, fieldIdRemaining, transistion, comments) {
    
    var userName = getUserName();
    
    item[fieldIdHas].add(userName);
    item[fieldIdRemaining].remove(userName);
    
    if(item[fieldIdRemaining].length === 1) {
        item.PREVIOUS_AUDITS.add(item.LAST_AUDIT_COMPLETED);
        item.LAST_AUDIT_COMPLETED = null;
        item.performWorkflowTransitionByCustomID(transistion, comments);
        setDates();
    }
    
    
}
function setDates(){
 
    var cycle = (item.CYCLE_MONTH === null) ? 12 : Number(item.CYCLE_MONTHS);
    var dateNext = new Date();
        dateNext.setMonth(dateNext.getMonth() + cycle);
    
    item.LAST = new Date();
    item.NEXT = dateNext;
    
}