// This script is part of the REQUIREMENTS MANAGEMENT app available in the App Store
// Last modification date: Jan 25, 2022


function updateValidationProcess() {
    updateRelatedGrid('VALIDATION_PROCESS', 'VALIDATION_PROCESS', 'BASE_REQUIREMENT', null);
}





function updateRelatedGrid(fieldNew, fieldOld, colReference, colDate) {
    
    var valueNew = item[fieldNew];
    var valueOld = item[fieldOld];
    
    if(valueNew !== valueOld) {
    
        addToGrid(valueNew, colDate, colReference);
        removeFromGrid(valueOld, colReference);
        item[fieldOld] = item[fieldNew];
    
    } else {
        
        updateExistingGrid(valueNew, colDate, colReference);
        
    }

}
function updateExistingGrid(parent, colDate, colReference) {
    
    if(parent !== null) {
    
        var bAdd    = true;
        var grid    = parent.grid;
        
        for(var i = 0; i < grid.length; i++) {
            var row = grid[i];
            if(row[colReference] === item) {
                bAdd = false;
                syncGridRow(row, colReference);
            }
        }
        
        if(bAdd) addToGrid(parent, colDate, colReference);
    
    }
    
}
function addToGrid(parent, colDate, colReference) {

    if(parent !== null) {

        var grid = parent.grid;
        var row  = grid.addRow();
        
        syncGridRow(row, colReference);
        
        row.RESULT = 'Pending';
        
        if(colDate !== null) row[colDate] = new Date();
        
    }
    
}
function syncGridRow(row, colReference) {
    
    var columns = Object.keys(row);
    var fields  = Object.keys(item);
    
    for(var i = 0; i < columns.length; i++) {
        
        var column = columns[i];
    
        if(column === colReference) { row[colReference] = item; }
        else if(column === "WORKFLOW_STATUS") { row.WORKFLOW_STATUS = item.descriptor.workflowState; }
        else {
            
            for(var j = 0; j < fields.length; j++) {
        
                var field = fields[j];
                if(field === column)  row[column] = item[field];
                
            }
            
        }
    
    }
    
}
function removeFromGrid(parent, colReference) {
    
   if(parent !== null) {
    
        var grid = parent.grid;
        
        for(var i = grid.length - 1; i >= 0; i--) {
            
            var row = grid[i];
            if(row[colReference] === item) row.remove();
            
        }
    
   }
    
}