// This script is part of the SUPPLIER COLLABORATION app available in the App Store
// Last modification date: Apr 12, 2023

var deliverablesCount   = 5;
var prefixPackage       = '';
var prefixSP            = 'SP-';

function grantSupplierAccess(elemToShare, elemPackage) {

    if(elemPackage === null) return null;
    
    var supplier  = elemPackage.SUPPLIER;
    var contact   = elemPackage.SUPPLIER_CONTACT_PERSON;
    var groupName = 'Supplier ' + supplier;

    if(contact !== null) {

        var userSelected    = contact.split(',');
        var lastName        = userSelected[0].trim();
        var firstName       = userSelected[1].trim();
        var userSearch      = Security.searchUsers({lastName:lastName, firstName:firstName}); 
        var owners          = elemToShare.master.additionalOwners;

        if(userSearch !== null) {

            var user =  Security.loadUser(userSearch[0].id);
            owners.push(user);

        }

    }
    
    if(supplier !== null) {
        
        if(typeof supplier === 'object') {
            supplier = supplier.descriptor.descriptor;
            if(typeof supplier.GROUP_NAME !== 'undefined') {
                if(supplier.GROUP_NAME !== '') {
                    groupName = supplier.GROUP_NAME;
                }
            }
        }
    
        var supplierGroup = Security.loadGroup(groupName);
    
        if(supplierGroup !== null) {
            if(supplierGroup.id !== '0') {
    
                var additionalGroups = elemToShare.master.groupAdditionalOwners;    
                    additionalGroups.push(supplierGroup);

                return supplierGroup;

            }
        }

    }

    return null;

}


function setMilestone(name, event, date, threshold, progress, deleteIfEmpty) {
   
    var milestoneIndex = -1;
    var targetDate     = new Date();
    
    if(         date !== null) targetDate    = date;
    if(        event === null) event         = 'ENTER';
    if(    threshold === null) threshold     = 0;
    if(deleteIfEmpty === null) deleteIfEmpty = true;
    
    var day = targetDate.getDay();
    
         if(day === 0) targetDate.setDate(targetDate.getDate() + 1);
    else if(day === 6) targetDate.setDate(targetDate.getDate() + 2);
 
    for(var i = 0; i < item.milestones.length; i++) {
        if(item.milestones[i].workflowStateName == name) {
            if(item.milestones[i].milestoneType == event) {
                milestoneIndex = i;
                break;
            }
        }
    }
    
    if(deleteIfEmpty) {
        if (date === null) {
            if(milestoneIndex > -1) {
                item.milestones.splice(milestoneIndex, 1);
            }
            return;
        }
    }
 
    if(milestoneIndex == -1) {
        
        var milestone = item.addMilestone();
            milestone.setWorkflowState(name);
            milestone.milestoneType = event;
            milestone.milestoneDate = targetDate;
            milestone.warnThreshold = threshold;
            milestone.progress = progress;
        
    } else {
        
        item.milestones[milestoneIndex].milestoneDate = targetDate;
        item.milestones[milestoneIndex].progress = progress;
        
    }
    
}


function getUserName() {
    var usr = Security.loadUser(userID);
    return usr.lastName + ', ' + usr.firstName;
}