// This script is part of the SUPPLIER COLLABORATION app available in the App Store
// Last modification date: Mar 22, 2023

var msg = [];

switch(customTransID) {

    case 'SUBMIT_TO_SUPPLIER':
        if(item.SUPPLIER === null) msg.push('Supplier must be defined before process can be submitted');
        if(item.SUPPLIER_CONTACT_PERSON === null) msg.push('Supplier Contact Person must be defined before process can be submitted');
        if(item.REQUESTOR === null) msg.push('Requestor must be defined before process can be submitted');
        validateContents();
        hasDeliverableTitles();
        break;

    case 'END_PROCESS_1':
    case 'END_PROCESS_2':
    case 'END_PROCESS_3':
    case 'END_PROCESS_4':
    case 'END_PROCESS_5':
    case 'END_PROCESS_6':
        if(item.PENDING_DELIVERABLES > 0) msg.push('There are still pending deliverables that must be completed before closing this process');
        break;
    
}

returnValue(msg);


function validateContents() {
    
    if(hasDeliverables()) return;

    if(item.attachments.length === 0) {
        if(item.grid.length === 0) {
            msg.push('The process cannot be submitted without any Files, Items or Deliverables');
        }
    }
    
}
function hasDeliverables() {

    for(var i = 1; i <= deliverablesCount; i++) {
        if(item['DELIVERABLE_' + i + '_TITLE'] !== null) return true;
    }

    return false;

}


function hasDeliverableTitles() {
    
    for(var i = 1; i <= deliverablesCount; i++) {
        if(item['DELIVERABLE_' + i + '_TITLE'] === null) {
            if((item['DELIVERABLE_' + i + '_DETAILS'] !== null) || (item['DELIVERABLE_' + i + '_TARGET_DATE'] !== null) || (item['DELIVERABLE_' + i + '_REFERENCE_FILE'] !== null)) {
                msg.push('Provide a title for Deliverable #' + i);
            }
        }
    }
    
}